Home | History | Annotate | Download | only in bin
      1 #!/bin/bash
      2 #
      3 # Build a kvm-ready Linux kernel from the tree in the current directory.
      4 #
      5 # Usage: kvm-build.sh config-template build-dir
      6 #
      7 # This program is free software; you can redistribute it and/or modify
      8 # it under the terms of the GNU General Public License as published by
      9 # the Free Software Foundation; either version 2 of the License, or
     10 # (at your option) any later version.
     11 #
     12 # This program is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     15 # GNU General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU General Public License
     18 # along with this program; if not, you can access it online at
     19 # http://www.gnu.org/licenses/gpl-2.0.html.
     20 #
     21 # Copyright (C) IBM Corporation, 2011
     22 #
     23 # Authors: Paul E. McKenney <paulmck (at] linux.vnet.ibm.com>
     24 
     25 config_template=${1}
     26 if test -z "$config_template" -o ! -f "$config_template" -o ! -r "$config_template"
     27 then
     28 	echo "kvm-build.sh :$config_template: Not a readable file"
     29 	exit 1
     30 fi
     31 builddir=${2}
     32 if test -z "$builddir" -o ! -d "$builddir" -o ! -w "$builddir"
     33 then
     34 	echo "kvm-build.sh :$builddir: Not a writable directory, cannot build into it"
     35 	exit 1
     36 fi
     37 
     38 T=${TMPDIR-/tmp}/test-linux.sh.$$
     39 trap 'rm -rf $T' 0
     40 mkdir $T
     41 
     42 cp ${config_template} $T/config
     43 cat << ___EOF___ >> $T/config
     44 CONFIG_INITRAMFS_SOURCE="$TORTURE_INITRD"
     45 CONFIG_VIRTIO_PCI=y
     46 CONFIG_VIRTIO_CONSOLE=y
     47 ___EOF___
     48 
     49 configinit.sh $T/config O=$builddir
     50 retval=$?
     51 if test $retval -gt 1
     52 then
     53 	exit 2
     54 fi
     55 ncpus=`cpus2use.sh`
     56 make O=$builddir -j$ncpus $TORTURE_KMAKE_ARG > $builddir/Make.out 2>&1
     57 retval=$?
     58 if test $retval -ne 0 || grep "rcu[^/]*": < $builddir/Make.out | egrep -q "Stop|Error|error:|warning:" || egrep -q "Stop|Error|error:" < $builddir/Make.out
     59 then
     60 	echo Kernel build error
     61 	egrep "Stop|Error|error:|warning:" < $builddir/Make.out
     62 	echo Run aborted.
     63 	exit 3
     64 fi
     65